import { A as Adapter, B as BetterAuthOptions, W as Where, a7 as FieldAttribute, a8 as FieldType, K as KyselyDatabaseType } from './auth-B-qaajUS.cjs';
export { ak as BetterAuthDbSchema, ab as FieldAttributeConfig, aj as InferFieldsFromOptions, ai as InferFieldsFromPlugins, af as InferFieldsInput, ag as InferFieldsInputClient, ae as InferFieldsOutput, ad as InferValueType, aa as InternalAdapter, ah as PluginFieldAttribute, am as accountSchema, ac as createFieldAttribute, a9 as createInternalAdapter, ar as getAllFields, al as getAuthTables, aA as mergeSchema, ay as parseAccountInput, at as parseAccountOutput, ax as parseAdditionalUserInput, av as parseInputData, aq as parseOutputData, az as parseSessionInput, au as parseSessionOutput, aw as parseUserInput, as as parseUserOutput, ao as sessionSchema, an as userSchema, ap as verificationSchema } from './auth-B-qaajUS.cjs';
import { z } from 'zod';
import 'kysely';
import 'better-call';
import './helper-Bi8FQwDD.cjs';
import './index-IbeXrsdr.cjs';
import 'jose';
import 'better-sqlite3';

declare function getWithHooks(adapter: Adapter, ctx: {
    options: BetterAuthOptions;
    hooks: Exclude<BetterAuthOptions["databaseHooks"], undefined>[];
}): {
    createWithHooks: <T extends Record<string, any>>(data: T, model: "user" | "account" | "session" | "verification", customCreateFn?: {
        fn: (data: Record<string, any>) => void | Promise<any>;
        executeMainFn?: boolean;
    }) => Promise<any>;
    updateWithHooks: <T extends Record<string, any>>(data: any, where: Where[], model: "user" | "account" | "session" | "verification", customUpdateFn?: {
        fn: (data: Record<string, any>) => void | Promise<any>;
        executeMainFn?: boolean;
    }) => Promise<any>;
    updateManyWithHooks: <T extends Record<string, any>>(data: any, where: Where[], model: "user" | "account" | "session" | "verification", customUpdateFn?: {
        fn: (data: Record<string, any>) => void | Promise<any>;
        executeMainFn?: boolean;
    }) => Promise<any>;
};

declare function toZodSchema(fields: Record<string, FieldAttribute>): z.ZodObject<{}, "strip", z.ZodTypeAny, {}, {}>;

declare function getAdapter(options: BetterAuthOptions): Promise<Adapter>;
declare function convertToDB<T extends Record<string, any>>(fields: Record<string, FieldAttribute>, values: T): T;
declare function convertFromDB<T extends Record<string, any>>(fields: Record<string, FieldAttribute>, values: T | null): T | null;

declare function matchType(columnDataType: string, fieldType: FieldType, dbType: KyselyDatabaseType): boolean;
declare function getMigrations(config: BetterAuthOptions): Promise<{
    toBeCreated: {
        table: string;
        fields: Record<string, FieldAttribute>;
        order: number;
    }[];
    toBeAdded: {
        table: string;
        fields: Record<string, FieldAttribute>;
        order: number;
    }[];
    runMigrations: () => Promise<void>;
    compileMigrations: () => Promise<string>;
}>;

declare function getSchema(config: BetterAuthOptions): Record<string, {
    fields: Record<string, FieldAttribute>;
    order: number;
}>;

export { FieldAttribute, FieldType, convertFromDB, convertToDB, getAdapter, getMigrations, getSchema, getWithHooks, matchType, toZodSchema };
